

#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "fft3def.h"
#include "sigdef.h"
#include "seldef.h"
#include "screendef.h"

float fmpow[32];
float fmbuf[64];

int iniflag=0;

float fmfix(int p0, float *z, float *pha)
{
int i, nn;
int i0, i1, i2;
float t1,t2;
t2=pha[0];
if(fm_n==0)
  {
  t1=atan2(z[2*p0+1],z[2*p0]);
  }
else
  {  
  nn=(p0-fm_size+baseband_size)&baseband_mask;
  for(i=0; i<fm_size; i++)
    {
    fmbuf[2*i  ]=fm_win[i]*z[2*nn  ];
    fmbuf[2*i+1]=fm_win[i]*z[2*nn+1];
    nn=(nn+1)&baseband_mask;
    }
  fftforward(fm_size, fm_n, fmbuf, fm_tab, fm_permute, FALSE);
  t1=0;
  i1=0;
  for(i=0; i<fm_size; i++)
    {
    fmpow[i]=fmbuf[2*i]*fmbuf[2*i]+fmbuf[2*i+1]*fmbuf[2*i+1];
    if(t1 < fmpow[i])
      {
      t1=fmpow[i];
      i1=i;
      }
    }
  i0=(i1-1+fm_size)&(fm_size-1);    
  i2=(i1+1)&(fm_size-1);
  t1=atan2(  -fmpow[i0]*fmbuf[2*i0+1]+
              fmpow[i0]*fmbuf[2*i1+1]-
              fmpow[i0]*fmbuf[2*i2+1],
             -fmpow[i0]*fmbuf[2*i0  ]+
              fmpow[i0]*fmbuf[2*i1  ]-
              fmpow[i0]*fmbuf[2*i2  ]);
  t1+=(i0&1)*PI_L;           
  }
pha[0]=t1;
t1-=t2;
if(t1 > PI_L)t1-=2*PI_L;                
if(t1 < -PI_L)t1+=2*PI_L;
return t1;
}

void detect_fm(void)
{
float *zr;
float amp, r2, t2;
float t1, r1;
int p0, p1, p2, p3, last_point, len;
int i, mm, nn;
if(bg_coherent == 0)
  {
  zr=baseb_raw_orthog;
  }
else
  {
  zr=baseb_carrier;
  }  
// ************************  Step 1 ***********************
// Make an FM detector by computing the phase with atan2.
// then take the derivative to get the instantaneous 
// frequency.
// Return immediately if bg.fm_factor equals 10 since the
// corresponding filter would not reduce the bandwidth.
// ********************************************************
p0=baseb_pa;
last_point=(baseb_pa+mix2.new_points)&baseband_mask;
if(baseb_channels == 1)
  {
  if(bg.fm_factor == 10)
    {
    while(p0 != last_point)
      {
      baseb_out[2*p0  ]=fmfix(p0,baseb_raw,&fm0_ph1);
      baseb_out[2*p0+1]=0;      
      p0=(p0+1)&baseband_mask;
      }
    return;
    }
  else
    {
    while(p0 != last_point)
      {
      baseb_fm_demod[p0 ]=fmfix(p0,baseb_raw,&fm0_ph1);     
      p0=(p0+1)&baseband_mask;
      }
    }
  }
else
  {
  if(bg.fm_factor == 10)
    {
    while(p0 != last_point)
      {
      baseb_out[4*p0  ]=fmfix(p0,baseb_raw,&fm0_ph1);
      baseb_out[4*p0+1]=0;      
      baseb_out[4*p0+2]=fmfix(p0,zr,&fm0_ph2);
      baseb_out[4*p0+3]=0;      
      p0=(p0+1)&baseband_mask;
      }
    return;  
    }
  else
    {
    while(p0 != last_point)
      {
      baseb_fm_demod[2*p0  ]=fmfix(p0,baseb_raw,&fm0_ph1);
      baseb_fm_demod[2*p0+1]=fmfix(p0,zr,&fm0_ph2);
      p0=(p0+1)&baseband_mask;
      }
    }
  }
// ********************  Step 2 *************************
// Apply a low pass filter with rise and fall times as specified
// by fm_lowpass.
// The rise/fall time is specified by fmfil_rise.
// The flat region in between is fm_lowpass_len
// baseb_fm_demod[p0] corresponds to baseb_fm_raw[p0]
// Return immediately if bg.fm_mode equals zero
// ******************************************************
amp=1/fm_lowpass_ampsum;
len=fmfil_len/2+fmfil_rise+1;
p0=baseb_pa;
p1=(baseb_pa-fmfil_len-2*fmfil_rise+baseband_mask)&baseband_mask;
p2=(baseb_pa-fmfil_len-fmfil_rise+baseband_mask-1)&baseband_mask;
p3=(baseb_pa-fmfil_rise+baseband_size)&baseband_mask;
nn=p2;
r1=0;
if(baseb_channels == 1)
  {
  while(nn != p3)
    {
    r1+=baseb_fm_demod[nn];
    nn=(nn+1)&baseband_mask;
    }
  while(p0 != last_point)
    {
    r1+=baseb_fm_demod[p3]-baseb_fm_demod[p2];
    p3=(p3+1)&baseband_mask;
    t1=0;
    mm=p0;
    nn=p1;
    p2=(p2+1)&baseband_mask;
    for(i=0; i<fmfil_rise; i++)
      {
      t1+=fm_lowpass[i]*(baseb_fm_demod[mm]+baseb_fm_demod[nn]);
      nn=(nn+1)&baseband_mask;
      mm=(mm+baseband_mask)&baseband_mask;
      }
    p1=(p1+1)&baseband_mask;
    baseb_out[2*p0  ]=(t1+r1)*amp;
    baseb_out[2*p0+1]=0;
    p0=(p0+1)&baseband_mask;
    }
  }
else
  {
  r2=0;
  while(nn != p3)
    {
    r1+=baseb_fm_demod[2*nn  ];
    r2+=baseb_fm_demod[2*nn+1];
    nn=(nn+1)&baseband_mask;
    }
  while(p0 != last_point)
    {
    r1+=baseb_fm_demod[2*p3  ]-baseb_fm_demod[2*p2  ];
    r2+=baseb_fm_demod[2*p3  ]-baseb_fm_demod[2*p2+1];
    p3=(p3+1)&baseband_mask;
    t1=0;
    t2=0;
    mm=p0;
    nn=p1;
    p2=(p2+1)&baseband_mask;
    for(i=0; i<fmfil_rise; i++)
      {
      t1+=fm_lowpass[i]*(baseb_fm_demod[2*mm  ]+baseb_fm_demod[2*nn  ]);
      t2+=fm_lowpass[i]*(baseb_fm_demod[2*mm+1]+baseb_fm_demod[2*nn+1]);
      nn=(nn+1)&baseband_mask;
      mm=(mm+baseband_mask)&baseband_mask;
      }
    p1=(p1+1)&baseband_mask;
    baseb_out[4*p0  ]=(t1+r1)*amp;
    baseb_out[4*p0+1]=0;
    baseb_out[4*p0+2]=(t2+r2)*amp;
    baseb_out[4*p0+3]=0;
    p0=(p0+1)&baseband_mask;
    }
  }

/*          
// *********************  Step 3 ******************************
// These locations correspond to the same moment in time:
// baseb_fm_fil1[p0]
// baseb_fm_raw[p0-len]
// baseb_fm_demod1[p0-len]
//
// The filtered data is more accurate than the unfiltered
// data. 
// Frequency modulate the original signal with the
// filtered demodulated signal. That should compress
// the bandwidth because we apply (nearly) the same
// FM modulation but in the opposite phase.
p0=baseb_pa;
p1=(baseb_pa-len+baseband_size)&baseband_mask;
t1=fm1_ph1;
if(baseb_channels == 1)
  {
  while(p0 != last_point)
    {
    t1+=baseb_fm_fil1[p0];
    if(t1>PI_L)t1-=2*PI_L;
    if(t1<-PI_L)t1+=2*PI_L;

    baseb_compressed_fm1[2*p0  ]= baseb_raw[2*p1  ]*cos(t1)+
                                  baseb_raw[2*p1+1]*sin(t1);
    baseb_compressed_fm1[2*p0+1]= baseb_raw[2*p1+1]*cos(t1)+
                                 -baseb_raw[2*p1  ]*sin(t1);                                 
//    baseb_compressed_fm1[2*p0  ]=baseb_raw[2*p1  ];
//    baseb_compressed_fm1[2*p0+1]=baseb_raw[2*p1+1];
    p0=(p0+1)&baseband_mask;
    p1=(p1+1)&baseband_mask;
    }
  }
fm1_ph1=t1;
*/


}  



